Package org.apache.catalina.ssi

# Class ByteArrayServletOutputStream

java.lang.Object
java.io.OutputStream
jakarta.servlet.ServletOutputStream
org.apache.catalina.ssi.ByteArrayServletOutputStream

All Implemented Interfaces:
  `Closeable`, `Flushable`, `AutoCloseable`

public class ByteArrayServletOutputStream extends ServletOutputStream
Class that extends ServletOutputStream, used as a wrapper from within `SsiInclude`

Author:
  Bip Thelin
See Also:
  - `and ByteArrayOutputStream`

## Field Summary

Fields
Modifier and Type
Field
Description
`protected final ByteArrayOutputStream`
`buf`
Our buffer to hold the stream.

## Constructor Summary

Constructors
Constructor
Description
`ByteArrayServletOutputStream()`
Construct a new ServletOutputStream.

## Method Summary

Modifier and Type
Method
Description
`boolean`
`isReady()`
TODO SERVLET 3.1
`void`
`setWriteListener(WriteListener listener)`
TODO SERVLET 3.1
`byte[]`
`toByteArray()`
`void`
`write(int b)`
Write to our buffer.

### Methods inherited from class jakarta.servlet.ServletOutputStream

`print, print, print, print, print, print, print, println, println, println, println, println, println, println, println`

### Methods inherited from class java.io.OutputStream

`close, flush, nullOutputStream, write, write`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### buf

protected final ByteArrayOutputStream buf
Our buffer to hold the stream.

## Constructor Details

### ByteArrayServletOutputStream

public ByteArrayServletOutputStream()
Construct a new ServletOutputStream.

## Method Details

### toByteArray

public byte[] toByteArray()

Returns:
  the byte array.

### write

public void write(int b)
Write to our buffer.

Specified by:
  `write` in class `OutputStream`
Parameters:
  `b` - The parameter to write

### isReady

public boolean isReady()
TODO SERVLET 3.1

Specified by:
  `isReady` in class `ServletOutputStream`
Returns:
  `true` if data can be written, else `false`

### setWriteListener

public void setWriteListener(WriteListener listener)
TODO SERVLET 3.1

Specified by:
  `setWriteListener` in class `ServletOutputStream`
Parameters:
  `listener` - The non-blocking IO write listener